<template>
  <div class="prev-next-menu">
    <button @click="prevClick" v-if="items.length > 1" :disabled="disabled">
      <UiCoreVIcon name="keyboard_arrow_left" class="icon" />
    </button>
    <!-- <ul v-if="items"> -->
    <transition-group name="slide" mode="in-out" tag="ul" v-if="items">
      <li
        v-for="(item, index) in items"
        :key="item.title"
        v-show="index === current"
      >
        <button>{{ item.title }}</button>
      </li>
    </transition-group>
    <!-- </ul> -->
    <button @click="nextClick" v-if="items.length > 1" :disabled="disabled">
      <UiCoreVIcon name="keyboard_arrow_right" class="icon" />
    </button>
  </div>
</template>

<script>
export default {
  props: {
    items: {
      type: Array,
      default: null,
    },
    disabled: {
      type: Boolean,
      default: null,
    },
  },

  data() {
    return {
      current: null,
    }
  },

  mounted() {
    this.current = this.items.length - 1
  },

  methods: {
    prevClick() {
      if (this.disabled) return

      this.current++
      if (this.current >= this.items.length) this.current = 0
      this.emit()
    },
    nextClick() {
      if (this.disabled) return

      this.current++
      if (this.current >= this.items.length) this.current = 0
      this.emit()
    },

    emit() {
      this.$emit('change', this.current)
    },
  },
}
</script>

<style lang="scss" scoped>
.prev-next-menu {
  @apply flex flex-row  overflow-hidden;
  height: 30px;

  ul {
    @apply p-0 m-0 mx-10;
  }

  button {
    outline: 0;
    border: none;
    cursor: pointer;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    @apply font-bold;
    .icon {
      margin-top: -4px;
      --v-icon-size: 35px;
    }

    transition: color 500ms, opacity 500ms;
    &[disabled] {
      cursor: initial;
      @apply text-grey;
      opacity: 0.4;
      text-decoration: none;
    }
  }
}
.slide-enter-active,
.slide-leave-active {
  transition: all 400ms ease;
}
.slide-enter {
  opacity: 0;
  transform: translateX(10%);
}
.slide-leave-active {
  opacity: 0;
  transform: translateX(-10%);
}

.slide-leave-active {
}
</style>
